<?php
/**
 * @file
 * Default theme implementation to display a node.
 */

	global $base_root, $base_url;

	if (isset($node->field_portfolio_style) && !empty($node->field_portfolio_style)) {
		$portfolio_style = $node->field_portfolio_style['und'][0]['value'];
	} else $portfolio_style = 'style1';

  	if(!$page){ ?>

  	<?php } else { ?>
	<!-- PORTFOLIO INFO -->
	<div class="container">
		<div class="row">			
			<!-- SIDEBAR -->
			<?php if ($portfolio_style == 'style3'): ?>
			<div class="col-md-4">
			<?php else: ?>
			<div class="col-sm-4 col-md-3">
			<?php endif; ?>
			<!-- PROJECT DETAIL -->
				<div class="port-detail-cont mb-30">
					<h4 class="blog-page-title mt-0 mb-20"><?php print t('PROJECT DETAILS') ?></h4>
					<div class="port-detail">
						<p>
							<strong><?php print t('CLIENT') ?>:</strong>
							<?php print $node->field_client['und'][0]['value']; ?>
						</p>
						<p>
							<strong><?php print t('DATE') ?>:</strong>
							<?php print format_date($node->created, 'custom', 'd F, Y') ?>
						</p>
						<p class="cate">
							<strong><?php print t('CATEGORY') ?>:</strong>
							<?php print strip_tags(render($content['field_portfolio_category']), '<a>'); ?>
						</p>
						<p>
							<strong><?php print t('ONLINE') ?>:</strong>
							<a href="<?php print $node->field_link_online['und'][0]['value'] ?>" target="_blank"><?php print $node->field_link_online['und'][0]['title'] ?></a>
						</p>
					</div>
				<?php if ($portfolio_style == 'style1'): ?>
					<div class="mb-50">
	                <?php
						hide($content['links']);
						hide($content['field_tags']);
						hide($content['comments']);
						hide($content['field_portfolio_category']);
						hide($content['field_images']);
						hide($content['field_link_online']);
						hide($content['field_client']);
						print render($content);
			        ?>
	                </div>
	            <?php endif; ?>
				</div>
            </div>
            <!-- CONTENT -->
            <?php if ($portfolio_style == 'style3'): ?>
            <div class="col-md-8 mb-80">
			<?php
				hide($content['links']);
				hide($content['field_tags']);
				hide($content['comments']);
				hide($content['field_portfolio_category']);
				hide($content['field_images']);
				hide($content['field_link_online']);
				hide($content['field_client']);
				print render($content);
			?>
            </div>
        	<?php elseif ($portfolio_style == 'style1'): ?>
			<div class="col-sm-8 col-md-offset-1 mb-80">
				<?php foreach ($node->field_images['und'] as $key => $value) {
					$imageone = $node->field_images['und'][$key]['uri'];
					$image_url = file_create_url($imageone);
				?>
				<!-- IMG -->
				<div class="lightbox-item mb-30">
					<a href="<?php print $image_url; ?>" class="lightbox">
						<div class="port-img-overlay">
							<img class="port-main-img" src="<?php print $image_url; ?>" alt="<?php print $title; ?>">
						</div>
						<div class="port-overlay-cont">
							<div class="port-btn-cont">
								<div aria-hidden="true" class="icon_search"></div>
							</div>
						</div>
					</a>
				</div>
				<?php } ?>				
			</div>
			<?php else: ?>
			<?php $img = $node->field_images['und'][0]['uri']; ?>
			<div class="col-sm-8 col-md-offset-1 ">
				<div class="lightbox-item popup-gallery mb-30">
					<a href="<?php print file_create_url($img); ?>">
						<div class="port-img-overlay">
							<img class="port-main-img" src="<?php print file_create_url($img); ?>" alt="<?php print $title; ?>">
						</div>
						<div class="port-overlay-cont">
							<div class="port-btn-cont">
								<div aria-hidden="true" class="icon_search"></div>
							</div>
						</div>
					</a>
				</div>
			</div>
			<?php endif; ?>
        </div>
    </div>
    <?php if ($portfolio_style == 'style2'): ?>
	<div class="container">
		<div class="row mt-30 mb-60 ">			
			<div class="popup-gallery">
			<?php foreach ($node->field_images['und'] as $key => $value) {
				$imageone = $node->field_images['und'][$key]['uri'];
				$image_url = file_create_url($imageone);
				$image_thumb = image_style_url('image_400x225', $imageone);
			?>
				<!-- IMG -->
				<div class="col-sm-3 col-xs-6 mb-20">
					<div class="lightbox-item">
						<a href="<?php print $image_url; ?>">
							<div class="port-img-overlay">
								<img class="port-main-img" src="<?php print $image_thumb; ?>" alt="<?php print $title; ?>">
							</div>
							<div class="port-overlay-cont">
								<div class="port-btn-cont">
									<div aria-hidden="true" class="icon_search"></div>
								</div>
							</div>
						</a>
					</div>
				</div>
			<?php } ?>
			</div>
		</div>
	</div>
	<!-- DIVIDER -->
	<hr class="mt-0 mb-0">
	<div class="container">
		<div class="row p-80-cont">
			<div class="col-md-12">
				<h4 class="blog-page-title mt-0 mb-20"><?php print t('PROJECT DESCRIPTION'); ?></h4>
			</div>
			<div class="col-md-12">
			<?php
				hide($content['links']);
				hide($content['field_tags']);
				hide($content['comments']);
				hide($content['field_portfolio_category']);
				hide($content['field_images']);
				hide($content['field_link_online']);
				hide($content['field_client']);
				print render($content);
			?>	
			</div>
		</div>
	</div>
	<!-- CAROUSEL -->
	<div class="container mb-140">
		<div class="fullwidth-slider owl-carousel owl-arrows-bg owl-dark-bg owl-pag-2" >
		<?php foreach ($node->field_images['und'] as $key => $value) {
			$imageone = $node->field_images['und'][$key]['uri'];
			$image_url = image_style_url('image_1140x642', $imageone);;
		?>
		<!-- ITEM -->		
			<div class="item m-0">
				<div>
					<img alt="<?php print $title; ?>" src="<?php print $image_url; ?>">
				</div>
			</div>
		<?php } ?>
		</div>
	</div>
    <?php elseif ($portfolio_style == 'style3'): ?>
    <!-- CAROUSEL -->
	<div class="container mb-80">
		<div class="fullwidth-slider owl-carousel owl-arrows-bg owl-dark-bg owl-pag-2" >
		<?php foreach ($node->field_images['und'] as $key => $value) {
			$imageone = $node->field_images['und'][$key]['uri'];
			$image_url = image_style_url('image_1140x642', $imageone);;
		?>
		<!-- ITEM -->		
			<div class="item m-0">
				<div>
					<img alt="<?php print $title; ?>" src="<?php print $image_url; ?>">
				</div>
			</div>
		<?php } ?>
		</div>
	</div>
	<?php endif; ?>
    <!-- DIVIDER -->
	<hr class="mt-0 mb-0">

	<!-- WORK NAVIGATION -->
	<div class="work-navigation plr-10 clearfix">
		<?php print single_navigation ($node->type,$node->nid, 'prev') ?>
		<a href="<?php print $base_url ?>/portfolio" class="work-all" title="View all"><span class="icon icon-arrows-squares"></span></a>
		<?php print single_navigation ($node->type,$node->nid, 'next') ?>
	</div>
	<hr class="mt-0 mb-0">
  	<?php }

?>