<?php require_once(drupal_get_path('theme','hawell').'/tpl/header.tpl.php');?>
<?php
	if(!function_exists('trim_text')){
   		function trim_text($input, $length, $ellipses = true, $strip_html = true) {
    	//strip tags, if desired
		    if ($strip_html) {
		        $input = strip_tags($input);
		    }

		    //no need to trim, already shorter than trim length
		    if (strlen($input) <= $length) {
		        return $input;
		    }

		    //find last space within length
		    $last_space = strrpos(substr($input, 0, $length), ' ');
		    $trimmed_text = substr($input, 0, $last_space);

		    //add ellipses (...)
		    if ($ellipses) {
		        $trimmed_text .= '...';
		    }

		    return $trimmed_text;
		}
	}
	
	$page_title_bg = theme_get_setting('blog_background_breadcrumb','hawell');
   	if (!empty($page_title_bg)) {
        $page_title_background = file_create_url(file_load($page_title_bg)->uri);
    } else $page_title_background ='';

    if (isset($_GET['style'])) {
    	$blog_style = $_GET['style'];
    } else {
    	$blog_style = theme_get_setting('blog_style', 'hawell');
    }
    if (empty($blog_style)) $blog_style = 'right';
    if (arg(0) == 'node') {
    	$blog_style = '';
    }
    if (isset($node->field_sidebar) && !empty($node->field_sidebar)) {
		$sidebar = $node->field_sidebar['und'][0]['value'];
	} elseif (arg(0) == 'node') {
		$sidebar = 'right';
	} else $sidebar = '';

?>
<?php if ($sidebar == 'full'): ?>

<?php elseif (empty($page_title_background) || arg(0) == 'node'): ?>
<!-- PAGE TITLE -->
<div class="page-title-cont page-title-small grey-light-bg">
	<div class="relative container align-left">
		<div class="row">
			
			<div class="col-md-8">
				<h1 class="page-title"><?php print drupal_get_title(); ?></h1>
				<?php if(isset($node) && !empty($node->body['und'][0]['summary'])): ?>
				<div class="page-sub-title">
	                <?php print trim_text($node->body['und'][0]['summary'], 40) ?>
	            </div>
	        	<?php endif; ?>
			</div>
			<?php if($breadcrumb): ?>
			<div class="col-md-4">
				<?php print $breadcrumb; ?>
			</div>
			<?php endif; ?>			
		</div>
	</div>
</div>
<?php else: ?>
<!-- PAGE TITLE LARGE IMG -->
<div class="page-title-cont page-title-large page-title-img grey-dark-bg pt-250" style="background-image: url(<?php print $page_title_background; ?>)">
	<div class="relative container align-left">
		<div class="row">			
			<div class="col-md-8">
				<h1 class="page-title"><?php print drupal_get_title(); ?></h1>
				<?php if(isset($node) && !empty($node->body['und'][0]['summary'])): ?>
				<div class="page-sub-title">
	                <?php print trim_text($node->body['und'][0]['summary'], 40) ?>
	            </div>
	        	<?php endif; ?>
			</div>
			
			<?php if($breadcrumb): ?>
			<div class="col-md-4">
				<?php print $breadcrumb; ?>
			</div>
			<?php endif; ?>			
		</div>
	</div>
</div>				
<?php endif; ?>
<?php if ($page['content']): ?>
	<!-- COTENT CONTAINER -->
	<?php
		if (!empty($tabs['#primary']) || !empty($tabs['#secondary'])):
			print render($tabs);
		endif;
		print $messages;
	?>
	<?php if ($sidebar == 'full'): ?>
	<div class="container p-80-cont">
	<?php else: ?>	
    <div class="container p-140-cont">
	<?php endif; ?>
		<div class="row <?php if ($blog_style == 'masonry_2col' || $blog_style == 'masonry_3col' || $blog_style == 'masonry_4col') print 'masonry'; ?>">
    	
		<?php if ($blog_style == 'full_width') { ?>
			<div class="col-sm-12 blog-main-posts">
			<?php print render($page['content']); ?>
			</div>
		<?php } elseif ($blog_style == 'left' || $sidebar == 'left') {?>
			<?php if ($page['sidebar']): ?>
			<!-- SIDEBAR -->
            <div class="col-sm-4 col-md-3">
            	<?php print render($page['sidebar']); ?>
            </div>
        	<?php endif; ?>
        	<!-- CONTENT -->
            <div class="col-sm-8 col-md-offset-1 blog-main-posts">
            <?php print render($page['content']); ?>
        	</div>
		<?php } elseif ($blog_style == 'right' || $sidebar == 'right') { ?>
			<!-- CONTENT -->
            <div class="col-sm-8 blog-main-posts">
            <?php print render($page['content']); ?>
        	</div>
        	<!-- SIDEBAR -->
        	<?php if ($page['sidebar']): ?>
            <div class="col-sm-4 col-md-3 col-md-offset-1">
            	<?php print render($page['sidebar']); ?>
            </div>
        	<?php endif; ?>
		<?php } elseif ($blog_style == 'small_image') { ?>
			<!-- CONTENT -->
            <div class="col-sm-8 blog-main-posts">          
               	<div class="row">
               	<?php print render($page['content']); ?>
           		</div>
       		</div>
			<?php if ($page['sidebar']): ?>
            <div class="col-sm-4 col-md-3 col-md-offset-1">
            	<?php print render($page['sidebar']); ?>
            </div>
        	<?php endif; ?>
		<?php } else { ?>
			<?php print render($page['content']); ?>
		<?php } ?>
		</div>

	</div>
<?php endif; ?>
<?php if ($page['page_section']): ?>
	<?php print render($page['page_section']); ?>
<?php endif; ?>
<?php require_once(drupal_get_path('theme','hawell').'/tpl/footer.tpl.php');?>